QGIS Application - Feature request #54
label placement
2006-04-04 08:07 AM - Redmine Admin

Status: Closed

Priority: Low

Assignee: Martin Dobias

Category: Map Canvas

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 10113
Description

A wish: label placement should be improved,
especially for printing, avoiding overlapping and
collisions and repetion of the same label on several
islands of the same feature.

History

#1 - 2006-09-22 04:57 PM - Gavin Macaulay -

See also ticket #297 for other label related enhancement requests

#2 - 2007-11-10 12:57 PM - Martin Dobias

This really needs more time :-/

Martin

#3 - 2008-02-14 12:38 AM - hamish -

Hi,

You might look at v.label.sa in GRASS 6.3 for some nice algorithm,

v.label.sa: "Create paint labels, but use a Simulated Annealing algorithm to avoid overlaping labels."

v.label.sa_ makes a label-file from a GRASS vector map with labels created from attributes in the attached table. The labels are placed in as optimal

place as possible."

http://trac.osgeo.org/grass/browser/grass/trunk/vector/v.label.sa/

http://trac.osgeo.org/grass/browser/grass/trunk/vector/v.label.sa/annealing.c

good luck,

Hamish

#4 - 2008-05-02 09:59 AM - springmeyer -

+ 1 on this being a fairly critical. | would support prioritizing default collision avoidance / filtering as a first feature. This could be a checkbox in the label tab
that is on by default and would prevent layers from rendering all their labels when major overlap/collision will occur. This will help basic QGIS aesthetics
and performance. An example of the performance hit is that when rendering a world_borders shapefile ( ~500kb) and all the country name labels are
placed by default, QGIS hangs unresponsively for about 7 seconds. (I'm running 0.10.0 on Max OS 10.5 with 2GB ram and loading the shapefile from
http://thematicmapping.org/downloads/TM_WORLD_BORDERS_SIMPL-0.2.zip).

| just ran a quick comparison with this same sample data in uDIG, Mapwindow, and [[ArcMap]] and all three have either a default collision algorithm set or
an easy checkbox available to avoid collision and therefore render the world_borders shapefile much faster when labels are requested. This feature will

have a big impact on the first-impressions of new users if implemented.

I'll attach two graphics comparing the default labeling in ggis with the default labeling in mapwindow (with collision avoidance).

#5 - 2008-05-02 10:08 AM - springmeyer -

Here are the sample images:

QGIS

[[Image(qgis_world_borders_default_labeling.png)]]

Mapwindow

[[Image(mapwindow_world_borders_default_labeling.png)]]

#6 - 2008-05-02 10:18 AM - Gary Sherman

This will be addressed with the Google Summer of Code project to enhance labeling in QGIS.

#7 - 2008-05-02 12:37 PM - Stefano Costa -

Mapserver does the same thing (i.e. automatic removal of labels that collide until there are no collisions). See

http://mapserver.gis.umn.edu/docs/reference/mapfile/label (POSITION directive) and

http:/trac.osgeo.org/mapserver/browser/trunk/mapserver/maplabel.c#L196

This doesn't mean the same code can be used, but it shouldn't be difficult to re-use at least the same algorithm used there.

#8 - 2008-07-08 10:30 PM - Paolo Cavallini

The bug is a showstopper for milestone 1.0, IMHO

#9 - 2008-09-05 01:14 AM - Maciej Sieczka -

In #297 there is a somewhat related patch.

#10 - 2008-10-10 01:06 PM - Tim Sutton

We will be integrating the PAL label placement library for probably QGIS 1.1. They are finishing some changes and for other reasons we will not be
applying this change in QGIS 1.0.
Regards

Tim

#11 - 2009-05-04 02:43 AM - hamish -

Hi,

just to note that the project "Label placement for Quantum GIS" by
Martin Dobias has been accepted for the 2009 Google Summer of Code.

see http://www.osgeo.org/node/895

Hamish

#12 - 2009-07-10 08:53 AM - Paolo Cavallini

See also #297; they should be closed together

#13 - 2009-11-29 08:41 AM - Giovanni Manghi

- Resolution set to fixed
- Status changed from Open to Closed

This should be fixed with the new labelling framework now available in qgis-trunk.

Files

qgis_world_borders_default_labeling.png 225 KB 2008-05-02 springmeyer -

mapwindow_world_borders_default_labeling.png 91.6 KB 2008-05-02 springmeyer -
